### 24/06/2019. Ergasia 3, Pollapli Grammiki Palindromisi. 

### Solutions for Project 3 (A special thanks to Vasilis Katsianos for his great contribution to Project 3 and
### the commented text) 
### Course: Statistics II
### Designed by the STATISTICS GROUP 2018-19 
###    SAMIS TREVEZAS (BASIC RESPONSIBLE TO BLAME FOR)
###    VASILIS KATSIANOS (LORD OF THE LABS)
###    CHRISTINA GIANNADAKI, KONSTANTINA KATACHANA, LEONIDAS KORDALIS (GUEST STARS)
###    [Without the voluntary work of MSc students, this course would be limited to a theoretical
###    presentation and an insufficient lab work. A great thanks to all the contributors, including 
###    advanced undergraduate students who helped in the labs.]

### THIS CODE WITH COMMENTS FOR THE SOLUTIONS IS DISTRIBUTED ONLY FOR ACADEMIC PURPOSES
### AND CAN BE USED AND REDISTRIBUTED PARTLY ONLY FOR SUCH REASONS
### IT IS DESTINED FOR BEGINNERS IN R AND STATISTICS AND SPECIFICALLY DESIGNED
### FOR THE NEEDS OF THE STUDENTS OF THE COURSE  

### Task 1

## Question 1

anscombe
n = dim(anscombe)[1]
# It is a data frame containing 11 observations for 8 variables.
# Variables x1, x2 and x3 all comprise of the numbers from 4 to 14 arranged in a certain order.
# Variable x4 comprises of the number 8 repeated 10 times and the number 19.
# Variables y1, y2, y3 and y4 all comprise of random numbers in the interval (3, 13).

## Question 2

apply(anscombe, 2, "mean")
apply(anscombe, 2, "var")
# Variables x1, x2, x3 and x4 all have identical mean values and variances.
# Similarly, variables y1, y2, y3 and y4 all have identical mean values and variances up to the second decimal point.

## Question 3

attach(anscombe)
reg1 = lm(y1 ~ x1); reg1
reg2 = lm(y2 ~ x2); reg2
reg3 = lm(y3 ~ x3); reg3
reg4 = lm(y4 ~ x4); reg4
# We observe that the regression lines for all 4 data sets follow approximately the same equation y = 3 + 0.5 * x.

## Question 4

windows()
par(mfrow = c(2, 2), oma = c(0, 0, 2, 0))
plot(x1, y1, main = "First Data Set", xlim = c(4, 19), ylim = c(3, 13))
abline(reg1, col = "red", lty = 4, lwd = 2)
plot(x2, y2, main = "Second Data Set", xlim = c(4, 19), ylim = c(3, 13))
abline(reg2, col = "red", lty = 4, lwd = 2)
plot(x3, y3, main = "Third Data Set", xlim = c(4, 19), ylim = c(3, 13))
abline(reg3, col = "red", lty = 4, lwd = 2)
plot(x4, y4, main = "Fourth Data Set", xlim = c(4, 19), ylim = c(3, 13))
abline(reg4, col = "red", lty = 4, lwd = 2)
mtext("Comparison of Anscombe Data Scatter Plots", outer = TRUE, side = 3, font = 2)
# Plotting the 4 data sets in the same window, while using the same xlim and ylim options for all of the plots and
# adding the 4 regression lines to their respective plots, we reaffirm that all 4 of the regression lines are indeed
# identical.
# The first scatter plot appears to illustrate a simple linear relationship between x1 and y1.
# In the second scatter plot, while a relationship between the two variables is obvious, it is not linear so a normal
# linear regression model would not be suitable.
# In the third scatter plot, the distribution between x3 and y3 would appear to be perfectly linear if it was not
# offset by the one outlier which exerts enough influence to significantly alter the regression line.
# Finally, the fourth scatter plot illustrates an example when one high-leverage point is enough to produce a 
# linear relationship, possibly false, since all the other data points share a common x-value and therefore there
# is no way to judge if a linear relationship exists between the variables. 

## Question 5

summary(reg1)
summary(reg2)
summary(reg3)
summary(reg4)
# Again, we see that the only thing which appears to slightly differentiate among the 4 regression models are the
# residuals. The estimated regression coefficients, their standard errors, the t-values, the p-values, the estimated
# residual standard errors, the coefficients of determination and the F-statistics are all approximately the same.
# The purpose of these 4 data sets is to demonstrate both the importance of visualising data before analyzing them
# and the effect of outliers and other influential observations on their statistical properties.
# According to Francis Anscombe, they are intended to counter the impression among statisticians that numerical
# calculations are exact, but graphs are rough.

## Question 6

p = 2
windows()
par(mfrow = c(1, 3), oma = c(0, 0, 2, 0))
plot(reg2, 1, sub.caption = "")
plot(reg3, 1, sub.caption = "")
plot(reg4, 1, sub.caption = "")
mtext("Homoscedasticity and Uncorrelatedness Check", outer = TRUE, side = 3, font = 2)
# The purpose of the residual versus fitted plot is to check the assumptions of homoscedasticity and uncorrelatedness
# of the random errors through the standardised residuals of the regression.
# In the second regression, the residuals naturally appear to follow a very distinct non-linear pattern which clearly
# violates the assumption that the random errors are uncorrelated.
# In the third regression, we see again that the relationship among the residuals is offset by the one outlier.
# In the fourth regression, we reaffirm that there is no way to detect a relationship between the explanatory
# variable and the response variable.

windows()
par(mfrow = c(1, 3), oma = c(0, 0, 2, 0))
plot(reg2, 3, sub.caption = "")
plot(reg3, 3, sub.caption = "")
plot(reg4, 3, sub.caption = "")
mtext("Homoscedasticity and Uncorrelatedness Check", outer = TRUE, side = 3, font = 2)
# The purpose of the scale-location plot is the same as that of the previous one.

windows()
par(mfrow = c(1, 3), oma = c(0, 0, 2, 0))
plot(reg2, 2, sub.caption = "")
plot(reg3, 2, sub.caption = "")
plot(reg4, 2, sub.caption = "")
mtext("Normality Check", outer = TRUE, side = 3, font = 2)
# The Q-Q plot is a graphical method for comparing two probability distributions by plotting their quantiles against
# each other. Here, we compare the empirical distribution of the residuals with the normal distribution in order to
# check the normality assumption of the random errors of the regression.
# In the second regression, the assumption of normality is slightly violated due to the non-linear relationship
# between the 2 variables.
# In the third regression, the normality of the residuals is greatly violated due to the presence of the outlier.
# In the fourth regression, the residuals appear to be normally distributed. We remark the warning displayed by R
# explaining that observation 8 has leverage equal to 1 and is ommitted.
shapiro.test(reg2$residuals)
shapiro.test(reg3$residuals)
shapiro.test(reg4$residuals)
# The Shapiro-Wilk normality tests reaffirm what we observed from the Q-Q plots.

windows()
par(mfrow = c(1, 3), oma = c(0, 0, 2, 0))
plot(reg2, 4, sub.caption = "")
abline(h = qf(0.1, p, n - p), col = "blue", lty = 4, lwd = 2)
abline(h = qf(0.5, p, n - p), col = "red", lty = 4, lwd = 2)
plot(reg3, 4, sub.caption = "")
abline(h = qf(0.1, p, n - p), col = "blue", lty = 4, lwd = 2)
abline(h = qf(0.5, p, n - p), col = "red", lty = 4, lwd = 2)
plot(reg4, 4, sub.caption = "")
abline(h = qf(0.1, p, n - p), col = "blue", lty = 4, lwd = 2)
abline(h = qf(0.5, p, n - p), col = "red", lty = 4, lwd = 2)
mtext("Inluential Points Detection", outer = TRUE, side = 3, font = 2)
# The purpose of the Cook's distance plot is to detect highly influential points.
# In the second regression, observations 6 and 8 are worryingly influential.
# In the third regression, observation 6 is slightly influential, while observation 3 which is the outlier is of
# course highly influential.
# In the fourth regression, observations 4 and 7 are slightly influential. We remember that observation 8 has
# leverage equal to 1 so the corresponding Cook's distance is undefined and ommitted from the plot.
# Nevertheless, that observation is by definition extremely influential.

windows()
par(mfrow = c(1, 3), oma = c(0, 0, 2, 0))
plot(reg2, 5, sub.caption = "")
abline(v = 2 * p / n, col = "blue", lty = 4, lwd = 2)
abline(v = 3 * p / n, col = "red", lty = 4, lwd = 2)
plot(reg3, 5, sub.caption = "")
abline(v = 2 * p / n, col = "blue", lty = 4, lwd = 2)
abline(v = 3 * p / n, col = "red", lty = 4, lwd = 2)
plot(reg4, 5, sub.caption = "")
abline(v = 2 * p / n, col = "blue", lty = 4, lwd = 2)
abline(v = 3 * p / n, col = "red", lty = 4, lwd = 2)
mtext("High-Leverage Points Detection", outer = TRUE, side = 3, font = 2)
# The purpose of the Residuals vs Leverage plot is to detect high-leverage and influential points.
# In the second and third regressions, there are no high-leverage points.
# In the fourth regression, observation 8 has leverage equal to 1 which is the maximum attainable value so it
# obviously constitutes a high-leverage point.

?plot.lm
# Using the help function, we find out that the previous regression plots all make use of the internally standardised
# residuals calculated by the function rstandard(). We are going to verify this using what we have learnt.
# First we are going to verify whether the function hatvalues() calculates the leverage of the observations.
xbar = mean(x1)
Sxx = sum((x1 - xbar)^2)
leverage = (x1 - xbar)^2 / Sxx + 1 / n
hat = as.vector(hatvalues(reg1))
all.equal(leverage, hat)
# Next, we are checking that the function rstandard() calculates the internally standardised residuals.
internal = as.vector(reg1$residuals) / (summary(reg1)$sigma * sqrt(1 - leverage))
standard = as.vector(rstandard(reg1))
all.equal(internal, standard)
# Finally, we are verifying whether the function rstudent() calculates the externally standardised residuals which we
# need in order to check for outliers.
sigma = numeric(n)
for (i in 1:n) 
{
  sigma[i] = summary(lm(y1[-i] ~ x1[-i]))$sigma
}
external = as.vector(reg1$residuals) / (sigma * sqrt(1 - leverage))
student = as.vector(rstudent(reg1))
all.equal(external, student)

# Now we can move on to the outlier detection.
abs(rstudent(reg2)) > qt(0.95, n - p - 1)
abs(rstudent(reg2)) > qt(0.975, n - p - 1)
# In the second regression, observations 6 and 8 constitute outliers for a = 0.1, but not for a = 0.05.
abs(rstudent(reg3)) > qt(0.95, n - p - 1)
abs(rstudent(reg3)) > qt(0.975, n - p - 1)
abs(rstudent(reg3)) > qt(0.995, n - p - 1)
abs(rstudent(reg3)) > qt(0.9995, n - p - 1)
# In the third regression, observation 3 constitutes an outlier at every usual significance level.
abs(rstudent(reg4)) > qt(0.95, n - p - 1)
# In the fourth regression, the externally standardised residual corresponding to observation 8 is obviously
# undefined since it has leverage equal to 1. There do not appear to exist any outliers here.

### Task 2

## Question 1

ozone = read.table("ozone.txt", header = TRUE, row.names = 1)
n = dim(ozone)[1]
windows()
plot(ozone)
# As the previous task has LOUDLY illustrated we ALWAYS begin the regression analysis by plotting our data.
# The scatterplot matrix reveals that no linear relationship exists between the response variable maxO3 and the
# explanatory variables N12, S12, E12, W12. Therefore, these variables ought to be disregarded by the model selection
# process. On the other hand, there exists a fairly strong linear relationship with Ne12 and maxO3v and to a lesser
# extent with Vx, T12, T15. Lastly, we remark the almost perfect linear relationship between T12 and T15 which
# means that one of them must be disregarded by the model selection process.
cor(ozone)
# We reaffirm what the plots illustrated by calculating the Pearson correlation matrix.
full = lm(ozone)
summary(full)
# We remark that the residuals are fairly symmetrical around 0.
# Only Ne12 and maxO3v are statistically significant for a = 0.05, which was to be expected after looking at the
# scatterplot matrix.
# We have utilised 9 explanatory variables so the residual degrees of freedom are of course 10.
# The coefficient of determination takes a moderately high value which indicates that this specific regression model
# explains 75% of the variability of the response variable.
# The adjusted coefficient of determination takes a significantly lower value which is to be expected due to the high
# number of explanatory variables.
# The p-value of the F-test indicates that at least one explanatory variable is statistically significant.

## Question 2

attach(ozone)
# We are going to perform a backward selection method until all remaining explanatory variables are statistically
# significant at the level a = 0.05.
# The function update() literally updates and re-fits a model according to the specified modifications to its
# formula.
summary(full)
bwd = update(full, . ~ . - T12)
summary(bwd)
bwd = update(bwd, . ~ . - E12)
summary(bwd)
bwd = update(bwd, . ~ . - N12)
summary(bwd)
bwd = update(bwd, . ~ . - W12)
summary(bwd)
bwd = update(bwd, . ~ . - S12)
summary(bwd)
# If we had selected a = 0.1, we would have stopped here. This model has 4 explanatory variables, namely T15, Ne12,
# Vx and maxO3v.
bwd = update(bwd, . ~ . - Vx)
summary(bwd)
bwd = update(bwd, . ~ . - T15)
summary(bwd)
# We arrived at a model with only 2 explanatory variables, namely Ne12 and maxO3v which happen to be the same
# variables which were statistically significant from the start.

## Question 3

library(leaps)
sub = regsubsets(formula(full), ozone, nbest = 1, nvmax = 9, method = "exhaustive")
summary(sub)
# The summary illustrates the names of the variables selected for each subset size.
windows()
par(mfrow = c(2, 2), oma = c(0, 0, 2, 0))
plot(sub, scale = "bic", main = "Bayesian Information Criterion")
plot(sub, scale = "Cp", main = "Mallows's Cp")
plot(sub, scale = "adjr2", main = "Adjusted R-Squared")
plot(sub, scale = "r2", main = "R-Squared")
mtext("Comparison of Regression Subsets", outer = TRUE, side = 3, font = 2)
# The smallest BIC value is attained by the model with 4 explanatory variables, namely T15, Ne12, Vx and maxO3v.
data.frame(p = 2:10, BIC = summary(sub)$bic)
# We remark that the models with 3 and 2 explanatory variables have almost equal BIC values.
# The plot corresponding to Mallows's Cp is not helpful since it simply arranges the models in descending order
# according to their Cp value, not accounting for how close their Cp value is to p.
data.frame(p = 2:10, Cp = summary(sub)$cp)
# Excluding the full model for which Cp = p = 10, the model whose Cp value is closest to p while simultaneously
# having small enough p, is the one with p = 4.
# Therefore, the best model according to Mallows's criterion is the one with 3 explanatory variables, namely T15,
# Ne12 and maxO3v.
# The largest adjusted R-squared value is attained by the model with 6 explanatory variables, namely T15, Ne12, S12,
# W12, Vx and maxO3v. We remark that it would not be very desirable to select this model since it has a fairly large
# number of explanatory variables, of which S12 and W12 do not appear to have a linear relationship with maxO3.
data.frame(p = 2:10, AdjR2 = summary(sub)$adjr2)
# We also remark that the models with 5, 4 and 7 explanatory variables have almost equal adjusted R-Squared values.
# The R-squared increases monotonically as the number of explanatory variables increases so we do not consider it
# for the purposes of model selection.

## Question 4

# The function step() aims to find the model with the lowest AIC value. When asked to perform a forward selection, it
# starts from the model with no explanatory variables and iteratively adds new explanatory variables to the current
# model until no lower AIC value than the current one may be obtained.
empty = lm(maxO3 ~ 1)
fwd = step(empty, formula(full), direction = "forward")
summary(fwd)
# We arrived at a model with 4 explanatory variables, namely T15, Ne12, Vx and maxO3v, which is the same model we
# previously saw in the best subsets regression approach.

# In order to make a final choice of model we should more closely analyse the models with 3 and 4 explanatory
# variables. First, we calculate the corrected AIC of the 2 models, starting with the one selected through the
# forward method. For this model we have estimated the coefficients of the 4 explanatory variables, the intercept
# and the residual standard error so the total number of estimated parameters is k = 6.
k = 6
AIC(fwd) + 2 * k * (k + 1) / (n - k - 1)
# We repeat the same for the model with T15, Ne12 and maxO3v.
reg = update(fwd, . ~ . - Vx)
k = 5
AIC(reg) + 2 * k * (k + 1) / (n - k - 1)
# It appears that the model with the lowest corrected AIC value is again the one with 4 explanatory variables.

# Next, we perform some diagnostic checks for the 2 models, in order to ascertain that no assumptions are violated.
# This step is ABSOLUTELY necessary when conducting ANY regression modelling.
# We begin with the model selected through the forward method.
p = 5
windows()
par(mfrow = c(2, 2))
plot(fwd, 1)
plot(fwd, 2)
shapiro.test(fwd$residuals)
plot(fwd, 4)
abline(h = qf(0.1, p, n - p), col = "blue", lty = 4, lwd = 2)
abline(h = qf(0.5, p, n - p), col = "red", lty = 4, lwd = 2)
plot(fwd, 5)
abline(v = 2 * p / n, col = "blue", lty = 4, lwd = 2)
abline(v = 3 * p / n, col = "red", lty = 4, lwd = 2)
abs(rstudent(fwd)) > qt(0.95, n - p - 1)
abs(rstudent(fwd)) > qt(0.975, n - p - 1)
abs(rstudent(fwd)) > qt(0.995, n - p - 1)
# We repeat the same for the model with T15, Ne12 and maxO3v.
p = 4
windows()
par(mfrow = c(2, 2))
plot(reg, 1)
plot(reg, 2)
shapiro.test(reg$residuals)
plot(reg, 4)
abline(h = qf(0.1, p, n - p), col = "blue", lty = 4, lwd = 2)
abline(h = qf(0.5, p, n - p), col = "red", lty = 4, lwd = 2)
plot(reg, 5)
abline(v = 2 * p / n, col = "blue", lty = 4, lwd = 2)
abline(v = 3 * p / n, col = "red", lty = 4, lwd = 2)
abs(rstudent(reg)) > qt(0.95, n - p - 1)
abs(rstudent(reg)) > qt(0.975, n - p - 1)
abs(rstudent(reg)) > qt(0.995, n - p - 1)
abs(rstudent(reg)) > qt(0.9995, n - p - 1)
# Both models pass all diagnostic checks, but the model with 4 explanatory variables is slightly more resistant to
# outliers. Both models have some points with slightly high leverage, but absolutely no influential points.

# Based on all the information criteria, the adjusted coefficient of determination and the performance regarding
# outliers we are finally inclined to select the model with T15, Ne12, Vx and maxO3v as explanatory variables.
